Subject: Improve error handling for invalid types

Description

After introducing the Utility\TypeHandling functions, an InvalidArgumentException is thrown if some @var annotation uses a wrong
type (and certainly also if invalid types are used elsewhere). However, the exception doesn't (and can't) give any hint where the invalid
type was declared.

We have two options to improve this:

1) let the TypeHandling functions return FALSE if the type could not be parsed and throw a proper exception in the calling method
2) let the calling method catch the TypeHandling exceptions and rethrow a better exception

I'm all for solution 1)

Associated revisions

Revision bdcb2420 - 2011-09-09 14:03 - Robert Lemke

[BUGFIX] Type declaration errors give hint on root cause

The TypeHandling::parseType() function will now throw a more specific
exception which allows other code parts to display more meaningful
error messages if a variable type was declared wrongly.

Change-Id: 1010378956d80b66824bf9012b24ca36a8031c562

Resolves: #25816

History

#1 - 2011-04-07 13:56 - Andreas Forthner

Yes, as | have the same problem here currently: Please go for solution 1! -> | will include that in my serialization changes...

#2 - 2011-08-04 08:24 - Sebastian Kurfuerst
- Target version changed from 1.0 beta 1 to 1.0 beta 2

we won't manage this for betal anymore, postproning

#3 - 2011-08-04 08:24 - Sebastian Kurfuerst
- Tracker changed from Task to Bug
#4 - 2011-09-09 13:21 - Mr. Hudson

- Status changed from New to Under Review

Patch set 1 of change 1010378956d80b66824bf9012b24ca36a8031c562 has been pushed to the review server.
It is available at http://review.typo3.org/4877

#5 - 2011-09-09 13:21 - Robert Lemke
- Category set to Utility
- Assigned To set to Robert Lemke

#6 - 2011-09-09 14:03 - Mr. Hudson

Patch set 2 of change 1010378956d80b66824bf9012b24ca36a8031c562 has been pushed to the review server.
It is available at http://review.typo3.org/4877

#7 - 2011-09-09 14:21 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
